<?php
include_once (dirname(__FILE__).'/settings.php');
$GLOBALS['DeltaLogingeneralEndPoint']='https://loginv2.deltasoftware.it/API/';
$GLOBALS['DeltaLogin_PublicApiKey']=$apikey_Public;
$GLOBALS['DeltaLogin_PrivateApiKey']=$apiKey_Private;
if(session_status() !== PHP_SESSION_ACTIVE) session_start([
    'cookie_lifetime' => ((60*intval($setts['DurataSessione_minuti']))),
]);
$setts=DeltaLogin_getSettings($apiKey_Private);
	if(isset($_GET['DeltaLoginApplicationIdentifier'])){
		if($_GET['DeltaLoginApplicationIdentifier']!=$apikey_Public){
			unset($_COOKIE[$apikey_Public]);
        	unset($_SESSION[$apikey_Public]);
        }
		else{
			setcookie($apikey_Public,$_GET['DeltaLogincookietoken_Raw'],(time()+(60*intval($setts['DurataSessione_minuti']))),'/');
        	$_SESSION[$apikey_Public]=$_GET['DeltaLogincookietoken_Raw'];
			$_POST=json_decode($_GET['DeltaLoginPostVariables_Encoded'],true);
        	echo '<img src="'.DeltaLogin_currentURLDir().'/cookiepixel.php?'.
            'APIkey='.$apikey_Public.
            '&tokenraw='.$_GET['DeltaLogincookietoken_Raw'].
            '&timeduration='.(time()+(60*intval($setts['DurataSessione_minuti'])))
            .'" style="width:1px!important;height:1px!important;padding:0!important;margin:0!important">';
	    }
	}
$GLOBALS['DeltaLogin_GeneralSettings']=$setts;
function DeltaLogin_getSettings($apiKey_Private){
$ch = curl_init();
$data=array(
"APIKEY"=>$apiKey_Private,
);
curl_setopt($ch, CURLOPT_URL, $GLOBALS['DeltaLogingeneralEndPoint'].'getSettings.php?'.http_build_query($data));
curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
$result = curl_exec($ch);
curl_close($ch);
return json_decode($result,true);
}
function DeltaLogin_getToken($TTL,$apiKey_Private){
$ch = curl_init();
$data=array(
"APIKEY"=>$apiKey_Private,
"TTL"=>$TTL
);
curl_setopt($ch, CURLOPT_URL, $GLOBALS['DeltaLogingeneralEndPoint'].'private/getToken.php?'.http_build_query($data));
curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
$result = curl_exec($ch);
curl_close($ch);
return $result;
}
function DeltaLogin_SessionSave($apiKey_Private, $token){
$ch = curl_init();
$data=array(
"APIKEY"=>$apiKey_Private,
"EndPoint"=>DeltaLogin_findEndPoint(),
"GET"=>json_encode($_GET),
"POST"=>json_encode($_POST),
"TOKEN"=>$token,
);
curl_setopt($ch, CURLOPT_POSTFIELDS, $data);
curl_setopt($ch, CURLOPT_URL, $GLOBALS['DeltaLogingeneralEndPoint'].'saveSS.php');
curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
$result = curl_exec($ch);
curl_close($ch);
}
function DeltaLogin_findEndPoint(){
return explode('?',((isset($_SERVER['HTTPS']) && $_SERVER['HTTPS'] === 'on' ? "https" : "http") . "://$_SERVER[HTTP_HOST]$_SERVER[REQUEST_URI]"))[0];
}
function DeltaLogin_userCheck_API($apikey_Public,$apiKey_Private){
$ch = curl_init();
$data=array(
"APIKEY"=>$apiKey_Private,
"TOKEN"=>DeltaLogin_firstNotEmpty($_COOKIE[$apikey_Public],$_SESSION[$apikey_Public]),
);
curl_setopt($ch, CURLOPT_URL, $GLOBALS['DeltaLogingeneralEndPoint'].'getUser.php?'.http_build_query($data));
curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
$result = curl_exec($ch);
curl_close($ch);
return json_decode($result,true);
}
function DeltaLogin_firstNotEmpty($v1,$v2){
	if(!empty($v1))return $v1;
	return $v2;
}
function DeltaLogin_dologoutanyDevice($apiKey_Private,$apikey_Public,$userMail){
$ch = curl_init();
$data=array(
"APIKEY"=>($apiKey_Private),
"mail"=>($userMail),
);
curl_setopt($ch, CURLOPT_URL, 'https://loginv2.deltasoftware.it/API/logout.php?'.http_build_query($data));
curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
$result = curl_exec($ch);
curl_close($ch);
DeltaLogin_logout($apikey_Public);
}
function DeltaLogin_logout($apikey_Public){
$_COOKIE[$apikey_Public]='';
unset($_COOKIE[$apikey_Public]); 
setcookie($apikey_Public, null, -1, '/'); 
$_SESSION[$apikey_Public]='';
unset($_SESSION[$apikey_Public]);
}
function DeltaLogin_currentHOST(){
$protocol = ((!empty($_SERVER['HTTPS']) && $_SERVER['HTTPS'] != 'off') || $_SERVER['SERVER_PORT'] == 443) ? "https://" : "http://";
$url = $protocol . $_SERVER['HTTP_HOST'];
return $url;
}
function DeltaLogin_currentURLDir(){
return DeltaLogin_currentHOST().DeltaLogin_currentFile();
}
function DeltaLogin_currentFile(){
$host=DeltaLogin_currentHOST();
$indexDir= stream_resolve_include_path('');
$fileDir=dirname(__FILE__);
$fileDir=str_replace($indexDir,'',$fileDir).'/';
return str_replace('//','/',$fileDir);
}



function getUser(){
	$setts=DeltaLogin_getSettings($GLOBALS['DeltaLogin_PrivateApiKey']);
	$DeltaLoginCheckString=DeltaLogin_userCheck_API($GLOBALS['DeltaLogin_PublicApiKey'],$GLOBALS['DeltaLogin_PrivateApiKey']);
	if($DeltaLoginCheckString['status']=='ok'){
		return $DeltaLoginCheckString['email'];
	}
	else{
		$token=DeltaLogin_getToken($GLOBALS['DeltaLogin_GeneralSettings']['DurataSessione_minuti'],$GLOBALS['DeltaLogin_PrivateApiKey']);
		DeltaLogin_SessionSave($GLOBALS['DeltaLogin_PrivateApiKey'], $token);	
		$redirect="https://loginv2.deltasoftware.it?apikPub=".$GLOBALS['DeltaLogin_PublicApiKey']."&token=".$token;
    	echo '
<form style="display:none!important" action="'.$redirect.'" method="post" id="loginform">
<input type="submit" style="display:none!important">
</form>
<script type="text/javascript">
    document.getElementById(\'loginform\').submit();
</script>
';
    die();
	}
}
function logout(){
DeltaLogin_logout($GLOBALS['DeltaLogin_PublicApiKey']);
}
function logoutAnyDevice(){
	DeltaLogin_dologoutanyDevice($GLOBALS['DeltaLogin_PrivateApiKey'],$GLOBALS['DeltaLogin_PublicApiKey'],getUser());
}
?>